This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1254616 - Provider systemd is not functional on this host
Provider systemd is not functional on this host
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: puppet (Show other bugs)
25
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Dominic Cleal
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-08-18 09:53 EDT by Marcus Moeller
Modified: 2017-06-01 01:10 EDT (History)
15 users (show)

See Also:
Fixed In Version: puppet-4.2.1-5.fc25
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-06-01 01:10:09 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
workaround for the systemd confine (2.88 KB, patch)
2015-12-08 14:49 EST, Ian Wienand
no flags Details | Diff

  None (edit)
Description Marcus Moeller 2015-08-18 09:53:23 EDT
I am running puppet to enable or disable services using the systemd provider and I am getting the following error:

Error: /Stage[main]/Time::Service/Service[ntpd.service]: Provider systemd is not functional on this host

When I run it manually e.g. by executing:

systemctl enable ntpd.service

it works fine:

Created symlink from /etc/systemd/system/multi-user.target.wants/ntpd.service to /usr/lib/systemd/system/ntpd.service
Comment 1 Marcus Moeller 2015-08-19 02:59:04 EDT
This is a chroot setup, so puppet runs within the chroot. Within the chroot the directory /run/systemd/system does not exist, but now seems to be required by:

/usr/share/ruby/vendor_ruby/puppet/provider/service/systemd.rb

 confine :exists => "/run/systemd/system"
Comment 2 Ian Wienand 2015-12-03 21:18:50 EST
I found this problem too when using diskimage-builder in upstream nodepool to build fedora23 images.

I opened [1] and created [2] to see what we can do about this
 
[1] https://tickets.puppetlabs.com/browse/PUP-5577
[2] https://github.com/puppetlabs/puppet/pull/4481
Comment 3 Ian Wienand 2015-12-08 14:49 EST
Created attachment 1103692 [details]
workaround for the systemd confine

I have used this to successfully run puppet in a chroot on Fedora
Comment 4 Fedora End Of Life 2016-11-24 07:20:14 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Marcus Moeller 2016-12-15 04:01:58 EST
Still appears on F25. Not sure if your patch ever made it to the package.
Comment 6 Fedora Update System 2017-05-23 07:25:51 EDT
puppet-4.2.1-5.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-8ad8d1bd86
Comment 7 Dominic Cleal 2017-05-23 07:26:47 EDT
Thanks for sending the patch upstream, I've applied it to the Fedora 25 branch. F26 onwards should already contain it.
Comment 8 Fedora Update System 2017-05-24 03:10:51 EDT
puppet-4.2.1-5.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-8ad8d1bd86
Comment 9 Fedora Update System 2017-06-01 01:10:09 EDT
puppet-4.2.1-5.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.